// BkDlg.h : header file
//________________________________________
// CBkDlg dialog
class CBkDlg : public CDialog
{
// Construction
public:
	CBkDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CBkDlg)
	enum { IDD = IDD_BK_DIALOG };
	CButton	m_btnDll;
	CButton	m_btnCancel;
	CButton	m_btnXplus;
	CButton	m_btnXmoins;
	CButton	m_btnStop;
	CButton	m_btnGH;
	CButton	m_btnDH;
	CButton	m_btnReset;
	CString	m_s1;
	CString	m_s10;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	HINSTANCE m_hDLL;
	typedef BOOL (*OKAXE)(char axe);
	typedef BOOL (*APPELDX)(void);
	typedef BOOL (*LIBEREDX)(void);

	typedef void  (*INIT)(char axe);
	typedef void  (*RESET)(char axe);
	typedef void  (*RESETINTERRUPT)(char axe);
	typedef void  (*MOTORON)(char axe,long cte);
	typedef void  (*SETVELOCITY)(char axe,float v);
	typedef void  (*MOVEABSOLUTE)(char axe,float x);
	typedef void  (*MOVEABSOLUTE)(char axe,float x);
	typedef void  (*MOVERELATIVE)(char axe,float x);
	typedef void  (*WAITFORSTOP)(char axe);
	typedef float (*TELLPOSITION)(char axe);
	typedef void  (*DEFINEHOME)(char axe);
	typedef void  (*GOHOME)(char axe);
	typedef void  (*NBAXES)(char nb);
	typedef void  (*STOP)(char axe);
	typedef void  (*MOTORDESTINATION)(char axe);
	typedef char  (*MOTEURDESTINATION)(char axe);
	typedef char  (*BUTEE)(char axe);

	OKAXE OK;
	APPELDX AppelDX;
	LIBEREDX LibereDX;
	INIT IT;
	RESET RT;
	RESETINTERRUPT RI;
	MOTORON MN;
	SETVELOCITY SV;
	MOVEABSOLUTE MA;
	MOVERELATIVE MR;
	WAITFORSTOP WS;
	TELLPOSITION TP;
	DEFINEHOME DH;
	GOHOME GH;
	NBAXES NB;
	STOP ST;
	MOTEURDESTINATION MD;
	BUTEE BT;

	BOOL m_ok,m_OK;
	short m_iNb;

	// Generated message map functions
	//{{AFX_MSG(CBkDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnDh();
	afx_msg void OnGh();
	afx_msg void OnStop();
	afx_msg void OnXMoins();
	afx_msg void OnXPlus();
	afx_msg void OnReset();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDll();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
