// BkDlg.cpp : implementation file
//________________________________________
#include "stdafx.h"
#include "Bk.h"
#include "BkDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CBkDlg dialog
CBkDlg::CBkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBkDlg)
	m_s1 = _T("");
	m_s10 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBkDlg)
	DDX_Control(pDX, IDDLL, m_btnDll);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_X_PLUS, m_btnXplus);
	DDX_Control(pDX, IDC_X_MOINS, m_btnXmoins);
	DDX_Control(pDX, IDC_STOP, m_btnStop);
	DDX_Control(pDX, IDC_GH, m_btnGH);
	DDX_Control(pDX, IDC_DH, m_btnDH);
	DDX_Control(pDX, ID_RESET, m_btnReset);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	DDX_Text(pDX, IDC_STATIC10, m_s10);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBkDlg, CDialog)
	//{{AFX_MSG_MAP(CBkDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_DH, OnDh)
	ON_BN_CLICKED(IDC_GH, OnGh)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_X_MOINS, OnXMoins)
	ON_BN_CLICKED(IDC_X_PLUS, OnXPlus)
	ON_BN_CLICKED(ID_RESET, OnReset)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDDLL, OnDll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CBkDlg message handlers
void CBkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}
//________________________________________
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CBkDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
//________________________________________
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBkDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//________________________________________
BOOL CBkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_hDLL=LoadLibrary("C832DX.dll");
	if (m_hDLL!=NULL)
	{
		m_ok=TRUE;m_iNb=0;
		OK=(BOOL(*)(char axe))GetProcAddress(m_hDLL,"OK");
		if (OK==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		AppelDX=(BOOL(*)(void))GetProcAddress(m_hDLL,"AppelDX");
		if (AppelDX==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		LibereDX=(BOOL(*)(void))GetProcAddress(m_hDLL,"LibereDX");
		if (LibereDX==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		IT=(void(*)(char))GetProcAddress(m_hDLL,"IT");
		if (IT==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		RT=(void(*)(char))GetProcAddress(m_hDLL,"RT");
		if (RT==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		ST=(void(*)(char))GetProcAddress(m_hDLL,"ST");
		if (ST==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		RI=(void(*)(char))GetProcAddress(m_hDLL,"RI");
		if (RI==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		MN=(void(*)(char,long))GetProcAddress(m_hDLL,"MN");
		if (MN==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		SV=(void(*)(char,float))GetProcAddress(m_hDLL,"SV");
		if (SV==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		MA=(void(*)(char,float))GetProcAddress(m_hDLL,"MA");
		if (MA==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		MR=(void(*)(char,float))GetProcAddress(m_hDLL,"MR");
		if (MR==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		WS=(void(*)(char))GetProcAddress(m_hDLL,"WS");
		if (WS==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		TP=(float(*)(char))GetProcAddress(m_hDLL,"TP");
		if (TP==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		DH=(void(*)(char))GetProcAddress(m_hDLL,"DH");
		if (DH==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		GH=(void(*)(char))GetProcAddress(m_hDLL,"GH");
		if (GH==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		NB=(void(*)(char))GetProcAddress(m_hDLL,"NB");
		if (NB==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		MD=(char(*)(char))GetProcAddress(m_hDLL,"MD");
		if (MD==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		BT=(char(*)(char))GetProcAddress(m_hDLL,"BT");
		if (BT==NULL)
		{ 
			m_ok=FALSE;m_iNb++;
		}
		if (!m_ok)
		{
			m_s10.Format("%d fonction(s) non trouve(s) dans C832DX.dll !",m_iNb);
			m_btnXplus.EnableWindow(FALSE);
			m_btnXmoins.EnableWindow(FALSE);
			m_btnStop.EnableWindow(FALSE);
			m_btnDH.EnableWindow(FALSE);
			m_btnGH.EnableWindow(FALSE);
			m_btnReset.EnableWindow(FALSE);
		}
	}
	else
	{
		m_ok=FALSE;
		m_s10.Format("Librairie C832DX.dll non trouv !");
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnStop.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnGH.EnableWindow(FALSE);
		m_btnReset.EnableWindow(FALSE);
	}
	m_OK=FALSE;
	if (m_ok)
	{
		if (AppelDX()==TRUE)//Si DriverX est OK
		{
			m_OK=TRUE;
			RT(1);//Reset axe 1
			if (OK(1))//Si carte C832 est prsente
			{
				NB(1);//1 axe connect
				RT(1);//Reset axe 1
				RI(1);//Initialisation interruptions
				IT(1);//Init axe 1  avec les paramtres d'asservissement par dfaut
				MN(1,29600);//29600 : Moteur platine de rotation ON
				m_s1.Format("Alpha(): %1.3f",TP(1));
				m_btnXplus.EnableWindow(TRUE);
				m_btnXmoins.EnableWindow(TRUE);
				m_btnStop.EnableWindow(FALSE);
				m_btnDH.EnableWindow(TRUE);
				m_btnGH.EnableWindow(TRUE);
			}
			else
			{
				m_s10.Format("Carte C-832 non trouve !");
				m_s1="Alpha(): ?";
				m_btnXplus.EnableWindow(FALSE);
				m_btnXmoins.EnableWindow(FALSE);
				m_btnStop.EnableWindow(FALSE);
				m_btnDH.EnableWindow(FALSE);
				m_btnGH.EnableWindow(FALSE);
			}
		}
		else
		{
			m_s10.Format("Erreur appel DriverX ! (c832, Isa, Port 0x210, 0x4, Ignore...)");
			m_s1="?";
			m_btnXplus.EnableWindow(FALSE);
			m_btnXmoins.EnableWindow(FALSE);
			m_btnStop.EnableWindow(FALSE);
			m_btnDH.EnableWindow(FALSE);
			m_btnGH.EnableWindow(FALSE);
			m_btnReset.EnableWindow(FALSE);
		}
	}
	UpdateData(FALSE);	
	return TRUE;
}
//________________________________________
void CBkDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CBkDlg::OnCancel() 
{
	BOOL ok;
	if (m_OK)		//DriverX OK
	{

		if (OK(1))//Si carte C832 est prsente
		{
			ST(1);
		}
		KillTimer(1);

		m_s10.Format("DriverX libr...");
		UpdateData(FALSE);
		LibereDX();
		Sleep(300);
	}
	if (m_hDLL!=NULL)//Dll OK
	{
		ok=FreeLibrary(m_hDLL);
	}
	CDialog::OnCancel();
}
//________________________________________
void CBkDlg::OnDh() 
{
	//Define Home
	DH(1);
	m_s1.Format("Alpha(): %1.3f",0);
	UpdateData(FALSE);
}
//________________________________________
void CBkDlg::OnGh() 
{
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnDH.EnableWindow(FALSE);
	m_btnGH.EnableWindow(FALSE);
	m_btnStop.EnableWindow(TRUE);      
	m_btnDll.EnableWindow(FALSE);
	SV(1,180);
	MA(1,0);
	SetTimer(1,40,NULL);
}
//________________________________________
void CBkDlg::OnStop() 
{
	//Clic sur le bouton Stop
	KillTimer(1);
	ST(1);
	WS(1);
	m_s1.Format("Alpha(): %1.3f",TP(1));
	RI(1);
	m_btnStop.EnableWindow(FALSE);      
	m_btnXplus.EnableWindow(TRUE);
	m_btnXmoins.EnableWindow(TRUE);
	m_btnDH.EnableWindow(TRUE);
	m_btnGH.EnableWindow(TRUE);
	m_btnDll.EnableWindow(TRUE);
	UpdateData(FALSE);
}
//________________________________________
void CBkDlg::OnXMoins() 
{
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnDH.EnableWindow(FALSE);
	m_btnGH.EnableWindow(FALSE);
	m_btnStop.EnableWindow(TRUE);      
	m_btnDll.EnableWindow(FALSE);
	SV(1,180.0);
	MR(1,-360.0);
	SetTimer(1,40,NULL);
}
//________________________________________
void CBkDlg::OnXPlus() 
{
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnDH.EnableWindow(FALSE);
	m_btnGH.EnableWindow(FALSE);
	m_btnStop.EnableWindow(TRUE);      
	m_btnDll.EnableWindow(FALSE);
	SV(1,180.0);
	MR(1,360.0);
	SetTimer(1,40,NULL);
}
//________________________________________
void CBkDlg::OnReset() 
{
	RT(1);
	m_s10.Format("Reset...");
	UpdateData(FALSE);
	Sleep(300);
	if (OK(1))
	{
		m_s1.Format("Alpha(): %1.3f",TP(1));
		m_s10.Format("Carte C-832 OK !");
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnStop.EnableWindow(FALSE);
		m_btnDH.EnableWindow(TRUE);
		m_btnGH.EnableWindow(TRUE);
	}
	else
	{
		m_s10.Format("Carte C-832 non trouve !");
		m_s1="Alpha(): ?";
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnStop.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnGH.EnableWindow(FALSE);
	}
	UpdateData(FALSE);
}
//________________________________________
void CBkDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	m_s10.Format("");
	/*
	if (BT(1))
	{
		KillTimer(1);
		m_btnStop.EnableWindow(FALSE);      
		s.Format("Surcourse axe X dtecte !");
		AfxMessageBox(s);
	}	                    
	else
	*/ 
	{ 
		m_s1.Format("Alpha(): %1.3f",TP(1));
		UpdateData(FALSE);
	}
	//Moteurs arrivs  destination
	if (MD(1)==1) 
	{
		KillTimer(1);
		m_btnStop.EnableWindow(FALSE);      
		m_btnGH.EnableWindow(TRUE);
		m_btnDH.EnableWindow(TRUE);
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnDll.EnableWindow(TRUE);
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CBkDlg::OnDll() 
{
	AfxMessageBox("PROTOTYPES des fonctions de C832DX.dll\n\nBOOL AppelDX(void);\nvoid LibereDX(void);\nBOOL Connect(void);\n\nvoid NB(char nbaxes);	//En premier : Nb. d'axes connects [1, 4], axe=0 non permis\nBOOL OK(char axe);	//Test prsence axe [0,4] (0: tous les axes)\nvoid AB(char axe);		//AborT (Arrt brutal, perte position !, voir ST)\nchar BT(char axe);    	//Test bute de fin de course\nvoid DH(char axe);    	//Define Home (Dfinition origine)\nvoid GH(char axe);    	//Go Home (Retour origine)\nvoid IT(char axe);    	//IniT (Paramtres d'asservissement par dfaut)\nvoid MA(char axe,float x);	//Move Absolute\nvoid MR(char axe,float x);     //Move Relative\nvoid MF(char axe);		//Motor oFf\nvoid MN(char axe,long Cte);	//Motor oN (Cte: 120000 (Trans) ou 29600 (Rot))\nchar MD(char axe);		//Moteur  Destination\nvoid RT(char axe);		//ReseT\nvoid RI(char axe);		//Reset Interruptions\nvoid ST(char axe);		//STop\nvoid SV(char axe,float v);	//Set Velocity (Maxi: 100mm/min ou 360/min)\nchar TB(char axe);             	//Tell Busy (Moteur en mvt)\nfloat TP(char axe);		//Tell Position (axe=0 non permis)\nvoid WS(char axe);		//Wait until Stop (Attente fin mvt)");	
}
